# Visualization
TKV3d
AIS

# AIS_PerpendicularRelation Class Reference

A framework to display constraints of perpendicularity
between two or more interactive datums. These
datums can be edges or faces.
.

`#include <AIS_PerpendicularRelation.hxx>`

Inheritance diagram for AIS_PerpendicularRelation:

[legend]

## Public Member Functions

Standard_EXPORT | AIS_PerpendicularRelation (const TopoDS_Shape &aFShape, const TopoDS_Shape &aSShape, const Handle(Geom_Plane)&aPlane)
| Constructs an object to display constraints of perpendicularity on shapes. This object is defined by a first shape aFShape, a second shape aSShape, and a plane aPlane. aPlane is the plane of reference to show and test the perpendicular relation between two shapes, at least one of which has a revolved surface. .
Standard_EXPORT | AIS_PerpendicularRelation (const TopoDS_Shape &aFShape, const TopoDS_Shape &aSShape)
| Constructs an object to display constraints of perpendicularity on shapes. This object is defined by a first shape aFShape and a second shape aSShape. .
virtual Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Geom_Transformation)&aTrsf, const Handle(Prs3d_Presentation)&aPresentation)
| computes the presentation according to a point of view given by <aprojector>. To be Used when the associated degenerated Presentations have been transformed by <atrsf> which is not a Pure Translation. The HLR Prs can't be deducted automatically WARNING :<atrsf> must be applied to the object to display before computation !!!
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Member Functions

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager3d)&aPresentationManager, const Handle(Prs3d_Presentation)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. .
Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Prs3d_Presentation)&aPresentation)

Calculates the 3D view aPresentation and its
updates. The latter are managed by
aPresentationManager. Each of the views in the
viewer and every modification such as rotation, for
example, entails recalculation.
It must be redefined to implement hidden line removal
for the object. The user never calls this method
himself. This is done via the InteractiveContext object
and is dependent on the point of view from which the
object is displayed.
.

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager2d)&aPresentationManager, const Handle(Graphic2d_GraphicObject)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 2D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. Note that this syntax is not used in AIS as that package only concerns 3D display. .
Standard_EXPORT void | ComputeSelection (const Handle(SelectMgr_Selection)&aSelection, const Standard_Integer aMode)

Recovers and calculates any sensitive primitive,
aSelection, available in Shape mode, specified by
aMode. As a rule, these are sensitive faces.
This method is defined as virtual. This enables you to
implement it in the creation of a new class of AIS
Interactive Object. You need to do this and in so
doing, redefine this method, if you create a class
which enriches the list of signatures and types.
.

Standard_EXPORT void | ComputeTwoFacesPerpendicular (const Handle(Prs3d_Presentation)&aPresentation)
Standard_EXPORT void | ComputeTwoEdgesPerpendicular (const Handle(Prs3d_Presentation)&aPresentation)

## Private Attributes

gp_Pnt | myFAttach
gp_Pnt | mySAttach

## Constructor & Destructor Documentation

Standard_EXPORT AIS_PerpendicularRelation::AIS_PerpendicularRelation | ( | const TopoDS_Shape & | aFShape,
|  | const TopoDS_Shape & | aSShape,
|  | const Handle(Geom_Plane)& | aPlane
| ) |

Standard_EXPORT AIS_PerpendicularRelation::AIS_PerpendicularRelation | ( | const TopoDS_Shape & | aFShape,
|  | const TopoDS_Shape & | aSShape
| ) |

## Member Function Documentation

Standard_EXPORT void AIS_PerpendicularRelation::Compute | ( | const Handle(PrsMgr_PresentationManager2d)& | aPresentationManager,
|  | const Handle(Graphic2d_GraphicObject)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_PerpendicularRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_PerpendicularRelation::Compute | ( | const Handle(PrsMgr_PresentationManager3d)& | aPresentationManager,
|  | const Handle(Prs3d_Presentation)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

virtual Standard_EXPORT void AIS_PerpendicularRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Geom_Transformation)& | aTrsf,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_PerpendicularRelation::ComputeSelection | ( | const Handle(SelectMgr_Selection)& | aSelection,
|  | const Standard_Integer | aMode
| ) | `[private, virtual]`

| Implements SelectMgr_SelectableObject.

Standard_EXPORT void AIS_PerpendicularRelation::ComputeTwoEdgesPerpendicular | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT void AIS_PerpendicularRelation::ComputeTwoFacesPerpendicular | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT const AIS_PerpendicularRelation::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from AIS_Relation.

## Field Documentation

gp_Pnt AIS_PerpendicularRelation::myFAttach `[private]`

gp_Pnt AIS_PerpendicularRelation::mySAttach `[private]`

The documentation for this class was generated from the following file:

- AIS_PerpendicularRelation.hxx